/* ## hacked down from linux asm/unistd.h */
#define sexit		  $1
#define fork		  $2
#define read		  $3
#define write		  $4
#define open		  $5
#define close		  $6
#define waitpid		  $7
#define creat		  $8
#define link		  $9
#define unlink		 $10
#define execve		 $11
#define chdir		 $12
#define time		 $13
#define mknod		 $14
#define chmod		 $15
#define lchown		 $16
#define lseek		 $19
#define getpid		 $20
#define mount		 $21
#define umount		 $22
#define setuid		 $23
#define getuid		 $24
#define stime		 $25
#define ptrace		 $26
#define alarm		 $27
#define pause		 $29
#define utime		 $30
#define access		 $33
#define nice		 $34
#define sync		 $36
#define kill		 $37
#define sysrename	 $38
#define mkdir		 $39
#define rmdir		 $40
#define sdup		 $41
#define pipe		 $42
#define times		 $43
#define brk		 $45
#define setgid		 $46
#define getgid		 $47
#define signal		 $48
#define geteuid		 $49
#define getegid		 $50
#define acct		 $51
#define umount2		 $52
#define ioctl		 $54
#define fcntl		 $55
#define setpgid		 $57
#define umask		 $60
#define chroot		 $61
#define ustat		 $62
#define dup2		 $63
#define getppid		 $64
#define getpgrp		 $65
#define setsid		 $66
#define sigaction	 $67
#define sgetmask	 $68
#define ssetmask    	 $69
#define setreuid	 $70
#define setregid	 $71
#define sigsuspend	 $72
#define sigpending	 $73
#define sethostname	 $74
#define setrlimit	 $75
#define getrlimit	 $76
#define getrusage	 $77
#define gettimeofday	 $78
#define settimeofday	 $79
#define getgroups	 $80
#define setgroups	 $81
#define select		 $82  
#define symlink		 $83
#define oldlstat	 $84
#define readlink	 $85
#define uselib		 $86
#define swapon		 $87
#define reboot		 $88
#define readdir		 $89
#define mmap		 $90  
#define munmap		 $91
#define truncate	 $92
#define ftruncate	 $93
#define fchmod		 $94
#define fchown		 $95
#define getpriority	 $96
#define setpriority	 $97
#define statfs		 $99
#define fstatfs		$100
#define ioperm		$101
#define socketcall	$102
#define syslog		$103
#define setitimer	$104
#define getitimer	$105
#define stat		$106


#define lstat		$107
#define fstat		$108
#define iopl		$110
#define vhangup		$111
#define idle		$112
#define vm86old		$113
#define wait4		$114
#define swapoff		$115
#define sysinfo		$116
#define ipc		$117
#define fsync		$118
#define sigreturn	$119
#define clone		$120
#define setdomainname	$121
#define uname		$122
#define modify_ldt	$123
#define adjtimex	$124
#define mprotect	$125
#define sigprocmask	$126
#define create_module	$127
#define init_module	$128
#define delete_module	$129
#define get_kernel_syms	$130
#define quotactl	$131
#define getpgid		$132
#define fchdir		$133
#define bdflush		$134
#define sysfs		$135
#define personality	$136
#define setfsuid	$138
#define setfsgid	$139
#define _llseek		$140
#define getdents	$141
#define _newselect	$142
#define flock		$143
#define msync		$144
#define readv		$145
#define writev		$146
#define getsid		$147
#define fdatasync	$148
#define _sysctl		$149
#define mlock		$150
#define munlock		$151
#define mlockall	$152
#define munlockall	$153
#define sched_setparam		$154
#define sched_getparam		$155
#define sched_setscheduler	$156
#define sched_getscheduler	$157
#define sched_yield		$158
#define sched_get_priority_max	$159
#define sched_get_priority_min	$160
#define sched_rr_get_interval	$161
#define nanosleep		$162
#define mremap			$163
#define setresuid		$164
#define getresuid		$165
#define vm86			$166
#define query_module		$167
#define poll			$168
#define nfsservctl		$169
#define setresgid		$170
#define getresgid		$171
#define prctl              	$172
#define rt_sigreturn	$173
#define rt_sigaction	$174
#define rt_sigprocmask	$175
#define rt_sigpending	$176
#define rt_sigtimedwait	$177
#define rt_sigqueueinfo	$178
#define rt_sigsuspend	$179
#define pread		$180
#define pwrite		$181
#define chown		$182
#define getcwd		$183
#define capget		$184
#define capset		$185
#define sigaltstack	$186
#define sendfile	$187
#define getpmsg		$188	
#define putpmsg		$189	
#define vfork		$190


/* cpp/as macros for Linux syscall words of 0 <--> 5 args 
No errno, for one thing. Just one return value. 
For use with Rideau's Linux eforth. #include this into the dictionary part of 
eforth.S after the other requisite macros.
*/

 /* sys_sync            ( --- )      example.  WORKS.   */
 /*                     flush Linux file to disk. Named syscall.  */
 /*                __CODE(4, "sync", SYNC  )
                movl $36,%eax
                int $0x80
                pushl   %eax
                __ENTER
                __NEXT
*/


/* macros take a name length, an index name from the above list, 
	a dictionary name  and an as label name. Season to taste.  */

.macro _syscall0 namelen, dictname, iname, asname,prev=0
	__CODE \namelen , \dictname, \asname,\prev
	movl \iname,%eax
	int $0x80
	pushl %eax
	__ENTER
	__NEXT
.endm
/*	.long PREVLAB	- USELESS!
.set PREVLAB, (\prev)*/

.macro _syscall1 namelen, dictname, iname, asname,prev=0
	__CODE \namelen, \dictname, \asname,\prev
	popl %ebx
	movl \iname,%eax 
	int $0x80 	
	pushl %eax
	__ENTER
	__NEXT
.endm

.macro _syscall2 namelen, dictname, iname, asname,prev=0
	__CODE \namelen, \dictname, \asname,\prev
	popl %ebx
	popl %ecx
	movl \iname,%eax
	int $0x80
	pushl %eax
	__ENTER
	__NEXT
.endm

.macro _syscall3 namelen, dictname, iname, asname,prev=0
	__CODE \namelen, \dictname, \asname,\prev
	popl %ebx
	popl %ecx
	popl %edx
	movl \iname,%eax
	int $0x80
	pushl %eax
	__ENTER
	__NEXT
.endm

.macro _syscall4 namelen, dictname, iname, asname,prev=0
	__CODE \namelen, \dictname, \asname,\prev
	popl %ebx
	popl %ecx
	popl %edx
	popl %esi
	movl \iname,%eax
	int $0x80
	pushl %eax
	__ENTER
	__NEXT
.endm


.macro _syscall5 namelen, dictname, iname, asname,prev=0
	__CODE \namelen, \dictname, \asname,\prev
	popl %ebx
	popl %ecx
	popl %edx
	popl %esi
	popl %edi
	movl \iname,%eax
	int $0x80
	pushl %eax
	__ENTER
	__NEXT
.endm


/* below here is what turns into actual code 
		(namelen,dictname,iname,asname) */

_syscall1,"sysexit",sexit,SEXIT,0
_syscall0,"fork",fork,FORK,SEXIT
_syscall3,"read",read,READ,FORK
_syscall3,"write",write,WRITE,READ
_syscall3,"open",open,OPEN,WRITE
_syscall1,"close",close,CLOSE,OPEN
_syscall3,"waitpid",waitpid,WAITPID,CLOSE
_syscall2,"create",creat,SYSCREAT,WAITPID
_syscall2,"link",link,LINK,SYSCREAT
_syscall1,"unlink",unlink,UNLINK,LINK
_syscall3,"execve",execve,EXECVE,UNLINK
_syscall1,"chdir",chdir,CHDIR,EXECVE
_syscall1,"time",time,TIME,CHDIR
_syscall3,"mknod",mknod,MKNOD,TIME
_syscall2,"chmod",chmod,CHMOD,MKNOD
_syscall3,"lchown",lchown,LCHOWN,CHMOD
_syscall3,"lseek",lseek,LSEEK,LCHOWN
_syscall0,"getpid",getpid,GETPID,LSEEK
_syscall5,"mount",mount,MOUNT,GETPID
_syscall1,"umount",umount,UNMOUNT,MOUNT
_syscall1,"setuid",setuid,SETUID,UNMOUNT
_syscall0,"getuid",getuid,UID,SETUID
_syscall1,"stime",stime,STIME,UID
_syscall4,"ptrace",ptrace,PTRACE,STIME
_syscall1,"alarm",alarm,ALARM,PTRACE
_syscall0,"pause",pause,PAUSE,ALARM
_syscall2,"utime",utime,UTIME,PAUSE
_syscall2,"access",access,ACCESS
_syscall1,"nice",nice,NICE
_syscall0,"sync",sync,SYNC
_syscall2,"signal",kill,KILL
_syscall2,"rename",sysrename,RENAME
_syscall2,"makedir",mkdir,MKDIR
_syscall1,"rmdir",rmdir,RMDIR
_syscall1,"dupfid",sdup,SDUP
_syscall1,"pipe",pipe,PIPE
_syscall1,"times",times,TIMES
_syscall1,"brk",brk,SYSBRK	/*eforthuservector*//*<=DRECK!*/
_syscall1,"setgid",setgid,SETGID
_syscall0,"gid",getgid,GETGID
_syscall2,"syssignal",signal,SIGNAL
_syscall0,"euid",geteuid,GETEUID
_syscall0,"egid",getegid,GETEGID
_syscall1,"acct",acct,ACCOUNT
_syscall3,"ioctl",ioctl,IOCTL
_syscall3,"fcntl",fcntl,FCNTL
_syscall2,"setpgid",setpgid,SETPGID
_syscall1,"umask",umask,UMASK
_syscall1,"temproot",chroot,TEMPROOT
_syscall2,"ustat",ustat,USTAT
_syscall2,"dup2fid",dup2,DUP2FID
_syscall0,"ppid",getppid,PPID
_syscall0,"pgrp",getpgrp,PGRP
_syscall0,"setsid",setsid,SETSID
_syscall3,"sigaction",sigaction,SIGACTION
_syscall2,"setreuid",setreuid,SETREUID
_syscall2,"setregid",setregid,SETREGID
_syscall1,"sigsuspend",sigsuspend,SIGSUSPEND
_syscall1,"sigpending",sigpending,SIGPENDING
_syscall2,"sethostname",sethostname,SETHOSTNAME
_syscall2,"setrlimit",setrlimit,SETRLIMIT
_syscall2,"getrlimit",getrlimit,GETRLIMIT
_syscall2,"getrusage",getrusage,GETRUSAGE
_syscall2,"gettimeofday",gettimeofday,GETTIMEOFDAY
_syscall2,"settimeofday",settimeofday,SETTIMEOFDAY
_syscall2,"groups",getgroups,GETGROUPS
_syscall2,"setgroups",setgroups,SETGROUPS
_syscall5,"select",select,SELECT
_syscall2,"symlink",symlink,SYMLINK
_syscall3,"readlink",readlink,READLINK
_syscall1,"uselib",uselib,USELIB
_syscall2,"swapon",swapon,SWAPON
_syscall3,"reboot",reboot,REBOOT
_syscall3,"readdir",readdir,READDIR

/*			(namelen,iname,dictname,asname
thefollowingtakesapointertosixunsignedlongsina"struct",
Itactuallycallsold_mmap.
*/

_syscall1,"mmap",mmap,MMAP
_syscall2,"munmap",munmap,MUNMAP
_syscall2,"truncate",truncate,TRUNCATE
_syscall2,"ftruncate",ftruncate,FTRUNCATE
_syscall2,"fchmod",fchmod,FCHMOD
_syscall3,"fchown",fchown,FCHOWN
_syscall2,"getpriority",getpriority,GETPRIORITY
_syscall3,"setpriority",setpriority,SETPRIORITY
_syscall2,"statfs",statfs,STATFS
_syscall2,"fstatfs",fstatfs,FSTATFS
_syscall3,"ioperm",ioperm,IOPERM
_syscall2,"socketcall",socketcall,SOCKETCALL
_syscall3,"syslog",syslog,SYSLOG
_syscall3,"setitimer",setitimer,SETITIMER
_syscall2,"getitimer",getitimer,GETITIMER
_syscall2,"stat",stat,STAT
_syscall2,"lstat",lstat,LSTAT
_syscall2,"fstat",fstat,FSTAT
_syscall1,"iopl",iopl,IOPL
_syscall0,"vhangup",vhangup,VHANGUP
_syscall0,"idle",idle,IDLE
_syscall1,"vm86old",vm86old,VM86OLD
_syscall4,"wait4",wait4,WAIT4
_syscall1,"swapoff",swapoff,SWAPOFF
_syscall1,"sysinfo",sysinfo,SYSINFO
_syscall5,"ipc",ipc,IPC
_syscall1,"fsync",fsync,FSYNC
_syscall1,"sigreturn",sigreturn,SIGRETURN
_syscall4,"clone",clone,CLONE
_syscall2,"setdomainname",setdomainname,SETDOMAINNAME
_syscall1,"uname",uname,UNAME
_syscall3,"modify_ldt",modify_ldt,MODIFY_LDT
_syscall1,"adjtimex",adjtimex,ADJTIMEX
_syscall3,"mprotect",mprotect,MPROTECT
_syscall3,"sigprocmask",sigprocmask,SIGPROCMASK
_syscall2,"create_module",create_module,CREATE_MODULE
_syscall2,"init_module",init_module,INIT_MODULE
_syscall1,"delete_module",delete_module,DELETE_MODULE
_syscall1,"get_kernel_syms",get_kernel_syms,GET_KERNEL_SYMS
_syscall4,"quotactl",quotactl,QUOTACTL
_syscall1,"getpgid",getpgid,GETPGID
_syscall1,"fchdir",fchdir,FCHDIR
_syscall2,"bdflush",bdflush,BDFLUSH
_syscall3,"sysfs",sysfs,SYSFS
_syscall1,"personality",personality,PERSONALITY
_syscall1,"setfsuid",setfsuid,SETFSUID
_syscall1,"setfsgid",setfsgid,SETFSGID
_syscall5,"_llseek",_llseek,_LLSEEK
_syscall3,"getdents",getdents,GETDENTS
_syscall2,"flock",flock,FLOCK
_syscall3,"msync",msync,MSYNC
_syscall3,"readv",readv,READV
_syscall3,"writev",writev,WRITEV
_syscall1,"getsid",getsid,GETSID
_syscall1,"fdatasync",fdatasync,FDATASYNC
_syscall1,"_sysctl",_sysctl,_SYSCTL
_syscall2,"mlock",mlock,MLOCK
_syscall2,"munlock",munlock,MUNLOCK
_syscall1,"mlockall",mlockall,MLOCKALL
_syscall0,"munlockall",munlockall,MUNLOCKALL
_syscall2,"sched_setparam",sched_setparam,SCHED_SETPARAM
_syscall2,"sched_getparam",sched_getparam,SCHED_GETPARAM
_syscall3,"sched_setscheduler",sched_setscheduler,SCHED_SETSCHEDULER
_syscall1,"sched_getscheduler",sched_getscheduler,SCHED_GETSCHEDULER
_syscall0,"sched_yield",sched_yield,SCHED_YIELD
_syscall1,"sched_get_priority_max",sched_get_priority_max,SCHED_GET_PRIORITY_MAX
_syscall1,"sched_get_priority_min",sched_get_priority_min,SCHED_GET_PRIORITY_MIN
_syscall2,"sched_rr_get_interval",sched_rr_get_interval,SCHED_RR_GET_INTERVAL
_syscall2,"nanosleep",nanosleep,NANOSLEEP
_syscall4,"mremap",mremap,MREMAP
_syscall3,"setresuid",setresuid,SETRESUID
_syscall3,"getresuid",getresuid,GETRESUID
_syscall2,"vm86",vm86,VM86
_syscall5,"query_module",query_module,QUERY_MODULE
_syscall3,"poll",poll,POLL
_syscall3,"nfsservctl",nfsservctl,NFSSERVCTL
_syscall3,"setresgid",setresgid,SETRESGID
_syscall3,"getresgid",getresgid,GETRESGID
_syscall5,"prctl",prctl,PRCTL
_syscall1,"rt_sigreturn",rt_sigreturn,RT_SIGRETURN
_syscall4,"rt_sigprocmask",rt_sigprocmask,RT_SIGRPOCMASK
_syscall2,"rt_sigpending",rt_sigpending,RT_SIGPENDING
_syscall4,"pread",pread,PREAD
_syscall4,"pwrite",pwrite,PWRITE
_syscall3,"chown",chown,CHOWN
_syscall2,"getcwd",getcwd,GETCWD
_syscall2,"capget",capget,CAPGET
_syscall2,"capset",capset,CAPSET
_syscall4,"sendfile",sendfile,SENDFILE
_syscall1,"vfork",vfork,VFORK	
